#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF=numeric_limits<int>::max();


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n,m;
    cin>>n>>m;
    vector<vector<int> > v(n);

    for(int i=0;i<n;i++){
        v[i].resize(m+2);
        for(int j=1;j<=m;j++){
            cin>>v[i][j];

        }
    }
    for(int i=1;i<=m;i++){
        v[0][i]+=v[0][i-1];
    }
    for(int i=m;i>0;i--){
        v[1][i]+=v[1][i+1];
    }

    int ans=INF;
    for(int i=1;i<m;i++){
        ans=min(ans,v[0][i]+v[1][i+2]);
    }
    ans=min(ans,v[1][1]);
    ans=min(ans,v[0][m]);
    cout<<ans<<endl;

    return 0;
}